/*
	版权所有 2009-2018 荆门泽优软件有限公司
	保留所有权利
	官方网站：http://www.ncmem.com
	官方博客：http://www.cnblogs.com/xproer
	产品首页：http://www.ncmem.com/webplug/http-uploader2/
	在线演示：http://www.ncmem.com/products/http-uploader/demo2/index.html
	开发文档：http://www.cnblogs.com/xproer/archive/2011/03/15/1984950.html
	升级日志：http://www.cnblogs.com/xproer/archive/2011/03/15/1985091.html
	示例下载：http://www.ncmem.com/download/up2/asp.net/up2.rar
	文档下载：http://www.ncmem.com/download/up2/up2-doc.rar
	联系邮箱：1085617561@qq.com
	联系QQ：1085617561
    版本：1.1
	更新记录：
		2009-11-05 创建
		2014-02-28 使用jquery优化代码并增强兼容性。
*/

//删除元素值
Array.prototype.remove = function(val)
{
	for (var i = 0, n = 0; i < this.length; i++)
	{
		if (this[i] != val)
		{
			this[n++] = this[i]
		}
	}
	this.length -= 1
}

var HttpUploaderErrorCode = {
	  "0": "发送数据错误"
	, "1": "接收数据错误"
	, "2": "域名未授权"
	, "3": "公司未授权"
	, "4": "访问本地文件错误"
    //md5
	, "200": "无打打开文件"
	, "201": "文件大小为0"
};

function HttpUploaderMgr()
{
    var _this = this;
	//http://www.ncmem.com/
	this.Domain = "http://" + document.location.host;
	
	this.Config = {
		"EncodeType"		: "gb2312"//UTF-8,GB2312。文件名称编码方式，与web.config-requestEncoding配置对应
		, "Version"			: "2,5,54,51373"
		, "Company"			: "荆门泽优软件有限公司"
		, "License"			: ""
		, "Debug"			: false//调试开关
		, "LogFile"			: "C:\\log.txt"//日志文件路径
		, "FileFilter"		: "*"//文件类型。所有类型：*。自定义类型：jpg,png,gif,bmp
	    //字节计算器：http://www.beesky.com/newsite/bit_byte.htm
	    //超过10MB建议选择HttpUploader6：http://www.ncmem.com/webplug/http-uploader6/index.asp
		, "FileSizeLimit"	: 10485760//允许上传的文件大小，默认10MB
		, "AllowMultiSelect": true//多选开关。true:开启多选。false:关闭多选
		, "CryptoType"      : "md5"//文件校验方式：md5,crc,sha1
		, "InitDir"			: "D:\\"//初始路径。示例：D:\\Soft
		, "Compress"		: ""//是否开启压缩。值：zip,gzip
		, "AppPath"			: ""//网站虚拟目录名称。子文件夹 web
		, "FileFieldName"	: "file"//文件字段名称
		, "Cookie"	        : ""//cookie
        , "Authenticate"    : {type:"ntlm",name:"",pass:""}//域环境信息
		, "PostUrl"			: "http://localhost:4854/asp.net/upload.aspx"
	    //x86
        , ie: {
            drop: { clsid: "4D2454F8-EB25-465f-B867-C2A3E9F3D4B4", name: "Xproer.HttpDroper2" }
            , part: { clsid: "6F3EB4AF-FC9C-4570-A686-88B4B427C6FE", name: "Xproer.HttpPartition2" }
            , path: "http://www.ncmem.com/download/up2/up2.cab"
        }
	    //x64
        , ie64: {
            drop: { clsid: "C9388115-887C-4d64-B175-F8F1AA5437BF", name: "Xproer.HttpDroper2x64" }
            , part: { clsid: "3AFFCB6D-55ED-4ada-A1EC-D7D87BA29E51", name: "Xproer.HttpPartition2x64" }
            , path: "http://www.ncmem.com/download/up2/up64.cab"
        }
        , firefox: { name: "", type: "application/npHttpUp2", path: "http://www.ncmem.com/download/up2/up2.xpi" }
        , chrome: { name: "npHttpUp2", type: "application/npHttpUp2", path: "http://www.ncmem.com/download/up2/up2.crx" }
        , edge: { protocol: "up2", port: 9300, visible: false }
        , exe: { path: "http://www.ncmem.com/download/up2/up2.exe" }
	};
	
	//附加参数
	this.Fields = {
		 "uname": "test"
		,"upass": "123456"
	};

	this.filesMap = new Object();//文件对象,(id,json),(id,json)
	this.Droper = null;
	this.ieParter = null;
	this.parter = null;//
	this.toolBar = null;//jquery object
	this.setupBar = null;
	this.setupBarExe = null;
	this.nat_loaded = false;
	
	this.postAll = function () { this.app.queuePost(); };
	this.part_files = function (ret)
	{
	    if (ret.files == null) return;
	    for (var i = 0, l = ret.files.length; i < l; ++i)
	    {
	        var f = ret.files[i];
	        this.addFileLoc(f);
	        //jQuery.extend(f, this.Fields);//附加字段
	        //jQuery.extend(f, { name: "test" });
	        //this.browser.updateFile(f);//增加扩展信息
	    }
	};
	this.drag_enter = function(arg){}
	this.drag_leave = function(arg){}
	this.drop_files = function (ret)
	{
	    this.part_files(ret);
	};
	this.post_complete = function (ret)
	{
	    var f = this.filesMap[ret.id];
	    f.postComplete();
		//服务器返回信息
	    //alert(ret.res);
	    f.remove();
	    delete f;
	    this.filesMap[ret.id] = null;
	};
	this.post_error = function (ret)
	{
	    if (ret.value == "12")
	    {
	        this.setupTip();
	        return;
	    }
	    if (ret.value == "2")
	    {
	        alert(HttpUploaderErrorCode[ret.value]);
	        return;
	    }
	    var f = this.filesMap[ret.id];
	    f.postError(ret);
	};
	this.post_process = function (ret)
	{
	    var f = this.filesMap[ret.id];
	    f.postProcess(ret);
	};
	this.queue_complete = function (ret)
	{
	};
	this.plugin_loaded = function (arg)
	{
	    this.nat_loaded = true;
	    this.toolBar.empty();
	    this.toolBar.replaceWith(this.uiToolBarBk);
	    //this.toolBar.show();
	};
	this.load_complete = function (json) {
	    //this.btnSetup.hide();
	    var needUpdate = true;
	    if (typeof (json.version) != "undefined") {
	        if (json.version == this.Config.Version) {
	            needUpdate = false;
	        }
	    }
	    if (needUpdate) this.update_notice();
	    //else { this.btnSetup.hide(); }
	};
	this.load_complete_edge = function (json) {
	    this.edge_load = true;
	    //this.btnSetup.hide();
	    _this.app.init();
	};
	this.recvMessage = function (str)
	{
	    var ret = JSON.parse(str);
        if      (ret.name == "part_files") _this.part_files(ret);
        else if (ret.name == "drag_enter") _this.drag_enter(ret);
        else if (ret.name == "drag_leave") _this.drag_leave(ret);
        else if (ret.name == "drop_files") _this.drop_files(ret);
        else if (ret.name == "post_complete") _this.post_complete(ret);
        else if (ret.name == "post_process") _this.post_process(ret);
        else if (ret.name == "post_error") _this.post_error(ret);
        else if (ret.name == "queue_complete") _this.queue_complete(ret);
        else if (ret.name == "plugin_loaded") _this.plugin_loaded(ret);
        else if (ret.name == "load_complete") { _this.load_complete(ret); }
        else if (ret.name == "load_complete_edge") { _this.load_complete_edge(ret); }
	};
    
	var browserName = navigator.userAgent.toLowerCase();
	this.ie = browserName.indexOf("msie") > 0;
    //IE11
	this.ie = this.ie ? this.ie : browserName.search(/(msie\s|trident.*rv:)([\w.]+)/) != -1;
	this.firefox = browserName.indexOf("firefox") > 0;
	this.chrome = browserName.indexOf("chrome") > 0;
	this.chrome45 = false;
	this.edge_load = false;
	this.chrVer = navigator.appVersion.match(/Chrome\/(\d+)/);
	this.ffVer = navigator.userAgent.match(/Firefox\/(\d+)/);
	this.edge = navigator.userAgent.indexOf("Edge") > 0;
	this.edgeApp = new WebServer(this);
	this.app = up2_app;
	this.app.edgeApp = this.edgeApp;
	this.app.Config = this.Config;
	this.app.ins = this;
	if (this.edge) { this.ie = this.firefox = this.chrome = this.chrome45 = false; }

    //浏览器环境检查
	if (_this.ie)
	{
	    //Win64
	    if (window.navigator.platform == "Win64")
	    {
	        jQuery.extend(this.Config.ie, this.Config.ie64);
	    }
	}
	else if (_this.firefox)
	{
	    if (!this.app.checkFF() || parseInt(this.ffVer[1]) >= 50)//仍然支持npapi
	    {
	        this.edge = true;
	        this.app.postMessage = this.app.postMessageEdge;
	        this.edgeApp.run = this.edgeApp.runChr;
	    }
	} //Chrome
	else if (_this.chrome)
	{
	    this.app.check = this.app.checkFF;
	    jQuery.extend(this.Config.firefox, this.Config.chrome);
	    //44+版本使用Native Message
	    if (parseInt(this.chrVer[1]) >= 44) {
	        _this.firefox = true;
	        if (!this.app.checkFF())//仍然支持npapi
	        {
	            this.edge = true;
	            this.app.postMessage = this.app.postMessageEdge;
	            this.edgeApp.run = this.edgeApp.runChr;
	        }
	    }
	}
	else if (this.edge)
	{
	    this.app.postMessage = this.app.postMessageEdge;
	}

    //升级通知
	this.update_notice = function () {
	    //this.btnSetup.text("升级控件");
	    //this.btnSetup.css("color", "red");
	    //this.btnSetup.show();
	};

	this.GetHtml = function ()
	{
	    //npapi
	    var acx = '<embed name="ffParter" type="' + this.Config.firefox.type + '" pluginspage="' + this.Config.firefox.path + '" width="1" height="1"/>';
	    if (this.chrome45) acx = "";
	    if (this.ie)
	    {
	        //加载拖拽控件
	        acx = '<object name="ieDroper" classid="clsid:' + this.Config.ie.drop.clsid + '"';
	        acx += ' codebase="' + this.Config.ie.path + '#version=' + this.Config["Version"] + '" width="192" height="192" >';
	        acx += '</object>';
	        //文件夹选择控件
	        acx += '<object name="ieParter" classid="clsid:' + this.Config.ie.part.clsid + '"';
	        acx += ' codebase="' + this.Config.ie.path + '#version=' + this.Config["Version"] + '" width="1" height="1" ></object>';
	    }
	    if (this.edge) acx = "";

	    //上传列表项模板
	    acx += '<div name="tmpItem" class="UploaderItem" id="UploaderTemplate">\
					<div class="UploaderItemLeft">\
						<div class="FileInfo">\
							<div name="fileName" class="FileName top-space">HttpUploader程序开发.pdf</div>\
							<div name="fileSize" class="FileSize" child="1">100.23MB</div>\
						</div>\
						<div class="ProcessBorder top-space"><div name="process" class="Process"></div></div>\
						<div name="msg" class="PostInf top-space">已上传:15.3MB 速度:20KB/S 剩余时间:10:02:00</div>\
					</div>\
					<div class="UploaderItemRight">\
						<div class="BtnInfo"><span name="btnCancel" class="Btn">取消</span>&nbsp;<span name="btnDel" class="Btn hide">删除</span></div>\
						<div name="percent" class="ProcessNum">35%</div>\
					</div>';
	    acx += '</div>';
	    //分隔线
	    acx += '<div name="spliter" class="spliter" id="FilePostLine"></div>';
	    //上传列表
	    acx += '<div name="pnlUpload" id="UploaderPanel">\
		            <div class="header">上传文件</div>\
		            <div name="toolbar" class="toolbar">\
		                <input name="btnAddFiles" id="btnAddFiles" type="button" value="选择多个文件" />\
		                <input name="btnAddFolder" id="btnAddFolder" type="button" value="选择文件夹" />\
		                <input name="btnPasteFiles" id="btnPasteFiles" type="button" value="粘贴文件" />\
		            </div>\
                    <div name="toolbar-setup" style="display:none;">\
		                <a name="exe-setup" href="">安装控件</a>\
		            </div>\
                    <div name="toolbar-upgrade" style="display:none;">\
		                <a name="exe-upgrade" href="">升级控件</a>\
		            </div>\
		            <div class="content">\
		                <div name="pnlUploaderList" id="FilePostLister"></div>\
		            </div>\
		        </div>';
	    return acx;
	};

	this.setupTip = function ()
	{
	    this.toolBar.html('<a href="'+this.Config["ExePath"]+'">请安装控件</a>').css("cursor", "pointer")
	};

    //在外部调用。
	this.loadAuto = function ()
	{
	    var html = this.GetHtml();
	    var ui = $(document.body).append(html);
	    this.InitUI(ui);
	};

	this.loadTo = function (oid)
	{
	    var html = this.GetHtml();
	    var ui = $("#" + oid).append(html);	    
	    this.InitUI(ui);
	};

	this.InitUI = function (ui/*jquery object*/)
	{
	    var pnlUpload    = ui.find('div[name="pnlUpload"]');
	    var lstUpload    = ui.find('div[name="pnlUploaderList"]');
	    var tmpItem      = ui.find('div[name="tmpItem"]');
	    var droper       = ui.find('object[name="objDroper"]').get(0);
	    this.ieParter    = ui.find('object[name="ieParter"]').get(0);
	    this.parter      = ui.find('embed[name="ffParter"]').get(0);
	    var btnAddFiles  = ui.find('input[name="btnAddFiles"]');
	    var btnAddFd     = ui.find('input[name="btnAddFolder"]');
	    var btnPasteFs   = ui.find('input[name="btnPasteFiles"]');
	    var lnkClear     = ui.find('a[name="btnClear"]');
	    var spliter      = ui.find('div[name="spliter"]');
	    this.toolBar     = ui.find("div[name='toolbar']");
	    this.setupBar    = ui.find("div[name='toolbar-setup']");
	    this.setupBarExe = ui.find("a[name='exe']");

	    this.filesUI   = lstUpload;
	    this.tmpFile   = tmpItem;
        this.tmpLine   = spliter;
	    this.Droper    = droper;

	    btnAddFiles.click(function () { _this.app.openFile(); });
	    btnAddFd.click(function () { _this.app.openFolder(); });
	    btnPasteFs.click(function () { _this.app.pasteFile(); });
	    lnkClear.click(function () { _this.ClearComplete(); });

	    $(function () {
	        if (!_this.edge) {
	            if (_this.ie) {
	                _this.parter = _this.ieParter;
	                if (null != _this.Droper) _this.Droper.StateChanged = _this.recvMessage;
	            }
	            _this.parter.StateChanged = _this.recvMessage;
	        }

	        if (_this.edge) {
	            _this.edgeApp.run();
	        }
	        else {
	            _this.app.init();
	        }
	    });
	};

	this.addFileLoc = function (f)
	{
	    //本地文件名称存在
	    //if (this.Exist(filePath)) return;
	    //此类型为过滤类型
	    //if (this.NeedFilter(filePath)) return;

	    var uper = new HttpUploader(f,this);
	    this.filesMap[f.id] = uper;
	    var ui = this.tmpFile.clone(true);
	    ui.css("display", "block");
	    this.filesUI.append(ui);//添加到文件列表

	    var line = this.tmpLine.clone();
	    line.css("display", "block");
	    this.filesUI.append(line);

	    var uiName      = ui.find("div[name='fileName']");
	    var uiSize      = ui.find("div[name='fileSize']")
	    var divProcess  = ui.find("div[name='process']");
	    var divMsg      = ui.find("div[name='msg']");
	    var btnCancel   = ui.find("span[name='btnCancel']");
	    var btnDel      = ui.find("span[name='btnDel']");
	    var divPercent  = ui.find("div[name='percent']");
	    var ui_eles = { msg: divMsg, percent: divPercent, process: divProcess, btn: {cancel:btnCancel,del:btnDel},panel:ui,spliter:line};

	    uper.ui = ui_eles;

	    uiName.text(f.name).attr("title", f.name);
	    uiSize.text(f.size);
	    divMsg.text("");
	    divPercent.text("0%");
	    btnCancel.click(function ()
	    {
	        var obj = $(this);
	        switch (obj.text())
	        {
	            case "暂停":
	            case "停止":
	                uper.stop();
	                break;
	            case "取消":
	                {
	                    uper.stop();
	                    uper.remove();
	                }
	                break;
	            case "续传":
	            case "重试":
	                uper.Post();
	                break;
	        }
	    });
	    btnDel.click(function () { uper.Delete(); });

	    uper.ready(); //准备
	};
}

var HttpUploaderState = {
	Ready: 0,
	Posting: 1,
	Stop: 2,
	Error: 3,
	GetNewID: 4,
	Complete: 5,
	WaitContinueUpload: 6,
	None: 7,
	Waiting: 8
};

//文件上传对象
function HttpUploader(f, mgr)
{
    var _this = this;
	//this.pMsg;
	//this.pProcess;
	//this.pPercent;
	//this.pButton
	//this.div
	//this.split
	//this.idLoc
	this.Manager = mgr; //上传管理器指针
	this.Config = mgr.Config;
	this.Fields = mgr.Fields;
	this.ActiveX = mgr.ActiveX;
	this.app = mgr.app;
	this.firefox = mgr.firefox;
	this.chrome = mgr.chrome;
	this.State = HttpUploaderState.None;
	this.fileLoc = f;
	this.ui = { msg: null, percent: null, process: null, btn: { cancel: null, del: null }, spliter: null, panel: null };

	this.ready = function ()
	{
	    this.ui.msg.text("正在上传队列中等待");
	};

	this.stop = function ()
	{
	    var inf = { name:"file_cancel",id: this.fileLoc.id };
        this.app.postMessage(inf);
	};

    //从上传列表中删除
	this.remove = function ()
	{
	    //删除信息层
	    this.ui.panel.remove();
	    //删除分隔线
	    this.ui.spliter.remove();
	};

	this.postError = function (json)
	{
	    this.ui.msg.text(HttpUploaderErrorCode[json.code]);
        this.ui.btn.cancel.text("重试");
        this.ui.percent.text("0%");
        this.ui.process.css("width", "0");
	};

	this.postComplete = function ()
	{
	    this.ui.btn.cancel.text("").hide();
	    this.ui.btn.del.hide();
	    this.ui.process.css("width", "100%");
	    this.ui.percent.text("100%");
	    this.ui.msg.text("上传完成");
	    this.State = HttpUploaderState.Complete;
	};

	this.postProcess = function (json)
	{
	    var msg = "已上传:" + json.len + " 速度:" + json.speed + " 剩余时间:" + json.time;
	    this.ui.msg.text(msg);
	    this.ui.percent.text(json.percent);
	    this.ui.process.css("width", json.percent);
	};
}